//=============================================================================
// DMWay
// A bot cannot be a human but human at least can do feign Bot
//=============================================================================
class DMWay expands KeyPoint;

//temporary beacon for server-find navigation
//And a lil loved
var float BestWeight;
var int j;
var bool bWorking;
//var float Time, F[2];
var Actor Path, OldGoal, TheGoal;
var MeBot Master;
var Vector HomeLocation, TmpHome;
var Rotator NewRot;
var TournamentPlayer P;
var Keypoint Kp[16];
var color clMsg;

function PostBeginPlay()
{
	HomeLocation=Location;
	bWorking=False;
	if (TournamentPlayer(Owner) != None)
		P = TournamentPlayer(Owner);
}

function CreateMyRoutes()
{
	if ( P != None )
	{
		Kp[0]=Self;
		Kp[1]=Spawn(Class'RCh1',P,,Location+vect(0,0,1));
		Kp[2]=Spawn(Class'RCh2',P,,Location+vect(0,0,2));
		Kp[3]=Spawn(Class'RCh3',P,,Location+vect(0,0,3));
		Kp[4]=Spawn(Class'RCh4',P,,Location+vect(0,0,4));
		Kp[5]=Spawn(Class'RCh5',P,,Location+vect(0,0,5));
		Kp[6]=Spawn(Class'RCh6',P,,Location+vect(0,0,6));
		Kp[7]=Spawn(Class'RCh7',P,,Location+vect(0,0,7));
		Kp[8]=Spawn(Class'RCh8',P,,Location+vect(0,0,8));
		Kp[9]=Spawn(Class'RCh9',P,,Location+vect(0,0,9));
		Kp[10]=Spawn(Class'RCh10',P,,Location+vect(0,0,10));
		Kp[11]=Spawn(Class'RCh11',P,,Location+vect(0,0,11));
		Kp[12]=Spawn(Class'RCh12',P,,Location+vect(0,0,12));
		Kp[13]=Spawn(Class'RCh13',P,,Location+vect(0,0,13));
		Kp[14]=Spawn(Class'RCh14',P,,Location+vect(0,0,14));
		Kp[15]=Spawn(Class'RCh15',P,,Location+vect(0,0,15));
	}
	DoHideThem();
}

function DoHideThem()
{
	local int i;

	for (i=1;i<16;i++)
	{
		if ( Kp[i] != None )
		{
			if (!Kp[i].bHidden )
				Kp[i].bHidden = True;
			Kp[i].SetOwner(Owner);
		}
	}
}

function Touch( Actor Other )
{
	//Nothing supposed to happen or do some coin zing-zang...
}

Event Destroyed()
{
	local int i;

	if ( P != None && !P.bDeleteMe ) //Usually UnSeen
		P.ClientMessage("Monster Beacon has expired...");
	for (i=1;i<16;i++)
	{
		if ( Kp[i] != None )
			Kp[i].Destroy();
	}
}

function DoSetChilds()
{
	local int i;

	for (i=1;i<16;i++)
	{
		if ( P.RouteCache[i] != None )
		{
			if (Kp[i] != None)
			{
				Kp[i].SetLocation(P.RouteCache[i].Location+vect(0,0,-20));
				if ( Kp[i].bHidden )
						Kp[i].bHidden = False;
			}
		}
		else
		{
			if (Kp[i] != None)
			{
				TmpHome=HomeLocation;
				TmpHome.Z+=i;
				Kp[i].SetLocation(TmpHome);
				if ( !Kp[i].bHidden )
					Kp[i].bHidden = True;
			}
		}
	}
}

function DoSayReach()
{
	if ( P != None )
	{
		if ( bWorking )
		{
			P.ClearProgressMessages();
			P.SetProgressMessage(TheGoal.GetHumanName()@"is Reachable!",1);
			clMsg.R=255;
			clMsg.G=128;
			clMsg.B=0;
			P.SetProgressColor(clMsg,1);
			P.SetProgressTime(3);
			DoResetChilds();
//			NewRot = Rotator(P.Destination - P.Location);
//			P.ClientSetLocation(P.Location,NewRot);
//			bWorking=False;
		}
	}
}

function DoSayHereButNoReach()
{
	if ( P != None )
	{
		if ( bWorking )
		{
			P.ClearProgressMessages();
			P.SetProgressMessage(TheGoal.GetHumanName()@"is Visible but Not very Reachable!",1);
			clMsg.R=255;
			clMsg.G=128;
			clMsg.B=0;
			P.SetProgressColor(clMsg,1);
			P.SetProgressTime(3);
			DoResetChilds();
//			NewRot = Rotator(P.Destination - P.Location);
//			P.ClientSetLocation(P.Location,NewRot);
//			bWorking=False;
		}
	}
}

function DoResetChilds()
{
	local int i;

	if ( bHidden )
		return;
	if ( Location != HomeLocation )
		SetLocation(HomeLocation);
	bHidden=True;
	for (i=1;i<16;i++)
	{
		if ( P.RouteCache[i] != None )
			P.RouteCache[i] = None;
		if (Kp[i] != None)
		{
			TmpHome=HomeLocation;
			TmpHome.Z+=i;
			if ( Kp[i].Location != TmpHome )
				Kp[i].SetLocation(TmpHome);
			if ( !Kp[i].bHidden )
				Kp[i].bHidden = True;
		}
	}
}

function ClaimTheTarget()
{
	if ( P != None )
	{
		P.ClearProgressMessages();
		P.SetProgressMessage("Hunting"@TheGoal.GetHumanName(),1);
		clMsg.R=255;
		clMsg.G=128;
		clMsg.B=0;
		P.SetProgressColor(clMsg,1);
		P.SetProgressTime(3);
	}
}

Auto State Tracking
{
Begin:
	Tag='DMWay';
	Sleep (2.00);
	if ( P != None )
		CreateMyRoutes();
DoTesting:
	Path=None;
	if ( P == None || P.bDeleteMe )
	{
		Destroy(); Goto('End');
	}
	if ( bDeleteMe ) Goto('End');
	if ( bWorking )
	{
		if ( Pawn(TheGoal) != None )
		{
			if ( OldGoal == None )
				OldGoal = TheGoal;

			if ( Pawn(TheGoal).Health < 1 || Pawn(TheGoal).bHidden || Pawn(TheGoal).bDeleteMe )
			{
				TheGoal = Master.FindAnEnemy(P);
				if ( TheGoal != None && OldGoal != None && TheGoal != OldGoal )
				{
					ClaimTheTarget();
					OldGoal = TheGoal;
				}
			}
		}
	}
	if ( bWorking && TheGoal != None )
	{
		if ( P.Physics == Phys_Falling || P.Health < 1)
			Goto ('TimeCycling');
		if ( P.ActorReachable(TheGoal) )
		{
			DoSayReach();
			bHidden=True;
			GoTo('TimeCycling');
		}
		else
		{
			if ( VSize(P.Location - TheGoal.Location) < 512 && FastTrace(P.Location,TheGoal.Location ))
			{
				DoSayHereButNoReach();
				GoTo('NoRouteCache');
			}
			P.bHunting = True;
			Path=P.FindPathToward(TheGoal);
		}
		if ( Path != None )
		{
			bHidden = False;
			SetLocation(Path.Location+vect(0,0,-20));
			DoSetChilds();
		}
		else
		{
NoRouteCache:
			DoResetChilds();
		}
	}
	TheGoal = Master.FindAnEnemy(P);
	if ( TheGoal != None && OldGoal != None && TheGoal != OldGoal )
	{
		ClaimTheTarget();
		OldGoal = TheGoal;
	}

TimeCycling:
	if ( bWorking )
		Sleep(1.5);
	else
	{
		Sleep (1.5);
		if ( P != None )
			DoResetChilds();
		Sleep(1.5);
	}
	GoTo('DoTesting');
End:
}

defaultproperties
{
	Texture=Texture'RC0'
	Style=STY_Translucent
	ScaleGlow=0.500000
	bStatic=False
	bNoDelete=False
	bOnlyOwnerSee=True
	bCollideActors=False
	RemoteRole=ROLE_DumbProxy
	NetUpdateFrequency=20.000000
	NetPriority=3.000000
	DrawScale=0.500000
	CollisionRadius=1.000000
	CollisionHeight=1.000000
}
